/**********************************************
*
*  UDPʐMɂDMMvvO
*
***********************************************/
#include "..\Include\StackTsk.h"
#include "..\Include\UDP.h"
#include "..\Include\Helpers.h"
#include "..\Include\LCDBlocking.h"
#include "..\Include\Delay.h"

extern NODE_INFO  remoteNode;
#define CONTROL_PORT	10002

const unsigned char VoltMsg[17] = "Volt=           ";
const unsigned char CurrMsg[17] = "Curr=           ";
const unsigned char OhmMsg[17]  = "Ohm =           ";
unsigned char DeltaString[17] = "Data=           ";
unsigned int CycleFlag, DemmandFlag;

/*****************************
*  VO}f^vt\
*
******************************/
void Mesure(void)
{
	signed long MesureData, Temp;	// 22bitvf[^
	unsigned int i, OverFlow;		// tO

	if(CycleFlag == 0)				// ϊJnTCNH
	{
		/// PϊJnTCN
		CycleFlag = 1;				// f[^̓TCNɐؑ
		SPI_CS_IO = 0;				// ϊJngK
		Nop();
		Nop();
		Nop();
		Nop();
		SPI_CS_IO = 1;				// gKI
		Delay10us(1);				// 10usecfBC
		SPI_CS_IO = 0;				// rW[mFp_~[CS
		Delay10us(1);				// 10usec
		SPI_CS_IO = 1;
	}
	else
	{
		/// f[^̓TCN
		CycleFlag = 0;				// ϊJnTCNɐؑ
		SPI_CS_IO = 0;				// f[^͗pfoCXI
		OverFlow = 0;				// f[^NA
		MesureData = 0;
		Delay10us(1);				// 10usec҂
		/// I[o[t[tO
		for(i=0; i<2; i++)
		{
			OverFlow << 1;
			SPI_CLK_IO = 0;			// CLOCK Low
			Nop();
			Nop();
			Nop();
			if(SPI_SDI_IO)			// 2rbg
				OverFlow ++;
			SPI_CLK_IO = 1;
		}
		/// 22rbgf[^́iōʃrbg͕j
		for(i=0; i<22; i++)
		{
			MesureData = MesureData << 1;	// PrbgVtg
			SPI_CLK_IO = 0;					// NbNpXo
			Nop();
			Nop();
			Nop();
			if(SPI_SDI_IO)
				MesureData ++;				// f[^
			SPI_CLK_IO = 1;
		}
		SPI_CS_IO = 1;						// foCXI
		/// f[^vZ 22rbg  32rbgɕϊ(t)
		MesureData = MesureData << 10;
		/// dAdAR̕\
		if(BUTTON0_IO)						// dH
		{
			if(BUTTON1_IO)					// PO{H
			{
				/// ől4096.0mVɌ킹(tj
				MesureData = MesureData / 0xCCCC;
				/// ɕϊ 
				strcpy(DeltaString, VoltMsg);	// 񏉊
				ltoa(MesureData, &DeltaString[6]);
				i = strlen(DeltaString);
				DeltaString[i] = DeltaString[i-1];
				DeltaString[i-1] = '.';
				DeltaString[i+1] = 'm';
				DeltaString[i+2] = 'V';
				DeltaString[i+3] = 0;
			}
			else	/// dPO{[h̏ꍇ	
			{
				/// ől40960mVɌ킹@R덷␳܂
				MesureData = MesureData / 0xCA3F;
				/// ɕϊ 
				strcpy(DeltaString, VoltMsg);	// 񏉊
				ltoa(MesureData, &DeltaString[6]);
				i = strlen(DeltaString);
				DeltaString[i] = 'm';
				DeltaString[i+1] = 'V';
				DeltaString[i+2] = 0;
			}			
		}
		else		/// dȐꍇ
		{
			if(BUTTON1_IO)		// d̏ꍇH
			{
				/// ől409.6mAɌ킹(0.1̒R̓dʍj
				MesureData = MesureData / 0x1510;
				strcpy(DeltaString, CurrMsg);	// 񏉊
				ltoa(MesureData, &DeltaString[6]);
				i = strlen(DeltaString);
				DeltaString[i] = DeltaString[i-1];
				DeltaString[i-1] = '.';				
				DeltaString[i+1] = 'm';
				DeltaString[i+2] = 'A';
				DeltaString[i+3] = 0;
			}
			else  /// Ȑꍇ@@1kɑ΂@V=(4.069V*X)/iX+1k)
			{
				MesureData = MesureData >> 10;	// 22bitɖ߂
				/// Rl@Ɍ킹
				Temp = (0x1FFFFF - MesureData);
				MesureData = (MesureData * 1000)/ Temp;
				/// ɕϊ 
				strcpy(DeltaString, OhmMsg);	// 񏉊
				ltoa(MesureData, &DeltaString[6]);
				i = strlen(DeltaString);
				DeltaString[i] = 0xF4;
				DeltaString[i+1] = 0;

			}			
		}
		// LCDɕ\o
		memset(LCDText, ' ', 16);
		strcpy(LCDText, DeltaString);		// \obt@ɃRs[
		if(DemmandFlag)
			LCDUpdate();					// \s
	}
}

/******************************
*  Control Process
*
******************************/
void UDPDMMTask(void)
{
	//// State	
	static enum {
		CONT_IDLE = 0,
		CONT_LISTEN,
		CONT_RECEIVE,
		CONT_EXEC
	} ContSM = CONT_IDLE;	
	
	NODE_INFO	Remote;
	unsigned int 	MsgLength, i;
	BYTE   buffer[40];
	static UDP_SOCKET 	MySocket;	

	///@UDPMbZ[WvZX 
	switch(ContSM)
	{
		/// ACh@҂	
		case CONT_IDLE:
			DemmandFlag = 1;				// [Jv\
			MySocket = UDPOpen(CONTROL_PORT, NULL, CONTROL_PORT);
			if(MySocket == INVALID_UDP_SOCKET)
				return;
			else
				ContSM++;
			break;
		/// MM҂
		case CONT_LISTEN:
			if(!UDPIsGetReady(MySocket))
				return;						// MȂ^[
			/// UDPf[^M
			MsgLength = 0;
			while(UDPGet(&buffer[MsgLength++]));
			UDPDiscard();					// \Pbg؂藣
			/// Mf[^ L[[h`FbN
			if(!(buffer[0] == 'S')) {
				ContSM = CONT_LISTEN;
				return;						// L[[hG[
			}			
			else	// L[[hOK
			{
				/// Mf[^vZX
				switch(buffer[1])			// 1ڃ`FbN
				{ 
					case 'P':				// vf[^v
						DemmandFlag = 1;	// vvI
						break;				// 
					case 'B':				// XCb`ԗv
						break;				// 
					case 'D':				// bZ[Wt\
						DemmandFlag = 0;	// vꎞ~v
						if(MsgLength < 35)
						{
							memset(LCDText, ' ', 32);
							memcpy(LCDText, &buffer[2], MsgLength-3);
						}
						else
							memcpy(LCDText, &buffer[2], 32);
						LCDUpdate();
						break;
					case 'E':				// \NA
						DemmandFlag = 1;
						LCDErase();
						break;
					default: break;			
 				}
    			ContSM++;				// Xe[^XXV
			}
		/// sʕԑ
		case CONT_EXEC:
			/// s
			if(!UDPIsPutReady(MySocket)) 
				return;
			else 
			{
				// ܂Ԃԑ
				switch(buffer[1])
				{
					case 'P':				// vʃf[^ԑ
						i = 0;
						while(DeltaString[i]!=0)
							UDPPut(DeltaString[i++]);
						break;						 
					case 'B':				// XCb`ԕԑ
						UDPPut('M');		// Key
						UDPPut('K');		// Button
						UDPPut(BUTTON0_IO ? '1':'0');
						UDPPut(BUTTON1_IO ? '1':'0');						
						UDPPut(BUTTON2_IO ? '1':'0');
						UDPPut(BUTTON3_IO ? '1':'0');
						break;
					case 'D':				// bZ[W\OKԑ
						UDPPut('M');
						UDPPut('D');
						UDPPut('O');
						UDPPut('K');
						break;
					case 'E':				// OKԑ
						UDPPut('M');
						UDPPut('E');
						UDPPut('O');
						UDPPut('K');
						break;
					default:				// R}hG[ԑ
						UDPPut('M');		// Key
						UDPPut('?');		// 
						break;
				}
				/// MIPAhXɕԑ
				memcpy((void*)&UDPSocketInfo[MySocket].remoteNode, (const void*)&remoteNode, sizeof(remoteNode));
				UDPFlush();
				ContSM = CONT_LISTEN;																									
			}
		default: break;
	}			
}	

		
	
